/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/include/Types.h"
#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Rename_select/include/Parameters.h"
#include <sstream>

namespace morpheo                    {
namespace behavioural {
namespace core {
namespace multi_ooo_engine {
namespace ooo_engine {
namespace rename_unit {
namespace rename_select {


#undef  FUNCTION
#define FUNCTION "Rename_select::msg_error"
  std::string Parameters::msg_error(void)
  {
    log_printf(FUNC,Rename_select,FUNCTION,"Begin");

    std::string msg = "";

    if ((_nb_front_end_select == 0) or
	(_nb_front_end_select > _nb_front_end))
      msg += "  - nb_front_end_select must be in [1:nb_front_end].\n";

    if ((_priority != PRIORITY_STATIC) and
	(_priority != PRIORITY_ROUND_ROBIN))
      msg += "  - Unsupported priority scheme. Supported scheme are : "+toString(PRIORITY_STATIC)+" and "+toString(PRIORITY_ROUND_ROBIN)+".\n";
    
    if ((_load_balancing != LOAD_BALANCING_BALANCE) and
	(_load_balancing != LOAD_BALANCING_MAXIMUM_FOR_PRIORITY))
      msg += "  - Unsupported load_balancing scheme. Supported scheme are : "+toString(LOAD_BALANCING_BALANCE)+" and "+toString(LOAD_BALANCING_MAXIMUM_FOR_PRIORITY)+".\n";

    return msg;

    log_printf(FUNC,Rename_select,FUNCTION,"End");
  };

}; // end namespace rename_select
}; // end namespace rename_unit
}; // end namespace ooo_engine
}; // end namespace multi_ooo_engine
}; // end namespace core

}; // end namespace behavioural
}; // end namespace morpheo              
